<template>
  <TcReportLayout format="A3">
    <template #params>
      <TcContextSelect v-model="params" />
      <div class="row q-col-gutter-x-md">
        <div class="col-6">
          <TcSelectInline
            v-model="params.stockTypes"
            label="Stock types"
            :options="stockTypeOptions"
            :multiple="true"
          />
        </div>
        <div class="col-6">
          <TcI2sNumberInput v-model="params.lowPressureThreshold" label="Low pressure threshold" unit-type="pressure" />
        </div>
        <div class="col-6">
          <TcI2sNumberInput
            v-model="params.highPressureThreshold"
            label="High pressure threshold"
            unit-type="pressure"
          />
        </div>
        <div class="col-6">
          <TcI2sNumberInput v-model="params.pressureGoal" label="Pressure goal" unit-type="percents" />
        </div>
      </div>
    </template>

    <TcPager v-if="data">
      <div class="row q-col-gutter-sm justify-around">
        <div class="col-6">
          <TcDataTable dense :data="tyresByStockType" />
        </div>
        <div class="col-6">
          <TcHighchart :value="tyresByTreadDepth" />
        </div>
        <div class="col-12">
          <TcHighchart :value="tyresByLocation" style="height: 600px;" />
        </div>
        <div class="col-6">
          <TcHighchart :value="tyresByBrand" style="height: 600px;" />
        </div>
        <div class="col-6">
          <TcHighchart :value="tyresByProduct" style="height: 600px;" />
        </div>
        <div class="col-6">
          <TcScorecard title="Pressure Goal" :value="pressureGoal" />
          <TcHighchart :value="tyresByPressureStatus" />
        </div>
        <div class="col-6">
          <TcHighchart :value="tyresByLife" />
        </div>
      </div>
    </TcPager>
  </TcReportLayout>
</template>

<script>
const dataSources = {
  locations: gql`
    query($where: TcLocationWhereInput, $cursor: String) {
      tcLocations(where: $where, cursor: $cursor) {
        nodes {
          id
          name
          tcFleet {
            id
            name
          }
        }
        cursor
      }
    }
  `,
  tyres: gql`
    query($where: TcTyreWhereInput, $cursor: String) {
      tcTyres(where: $where, cursor: $cursor) {
        nodes {
          id
          serialNumber
          stockType
          purchasePrice
          tcLocation {
            id
          }
          tcTyreMake {
            id
            name
          }
          tcTyreProduct {
            id
            name
          }
          tcTyreLife {
            id
            name
            type
          }
          measurements {
            minTreadDepth
            pressure
          }
        }
        cursor
      }
    }
  `,
}

export default {
  data() {
    return {
      params: {
        tcFleet: null,
        stockTypes: null,
        pressureGoal: 0.9,
        lowPressureThreshold: 4,
        highPressureThreshold: 8,
      },
      data: null,
    }
  },
  computed: {
    stockTypeOptions() {
      return [
        'rolling',
        'forScrap',
        'forService',
        'scrapped',
        'suspect',
        'forRetread',
        'stagingArea',
        'finalizeRetread',
      ].map(x => ({
        label: _.startCase(x),
        value: x,
      }))
    },
    tyresByStockType() {
      const { tyres, locations } = this.data
      const locationsById = _.keyBy(locations, 'id')
      return _.values(_.groupBy(tyres, 'stockType')).map(g => ({
        stockType: _.startCase(g[0].stockType),
        fleet: locationsById[g[0].tcLocation.id].tcFleet.name,
        count: g.length,
        price: _.sum(g.map(t => t.purchasePrice || 0)), // TODO: price is wrong
      }))
    },
    tyresByLocation() {
      const { tyres, locations } = this.data
      const locationsById = _.keyBy(locations, 'id')
      const step1 = _.values(_.groupBy(tyres, 'tcLocation.id')).map(g => ({
        location: locationsById[g[0].tcLocation.id].name,
        count: g.length,
        price: _.sum(g.map(t => t.purchasePrice || 0)), // TODO: price is wrong
      }))

      const step2 = _.orderBy(step1, ['price'], ['desc'])

      return {
        title: { text: 'Tyres by location' },
        chart: { type: 'column' },
        xAxis: {
          categories: step2.map(v => v.location),
        },
        yAxis: [
          {
            min: 0,
            title: { text: 'Price' },
          },
          {
            min: 0,
            title: { text: 'Count' },
            opposite: true,
          },
        ],

        series: [
          {
            name: 'Price',
            data: step2.map(v => v.price),
          },
          {
            name: 'Count',
            yAxis: 1,
            data: step2.map(v => v.count),
          },
        ],
      }
    },
    tyresByBrand() {
      const { tyres } = this.data
      const step1 = _.values(_.groupBy(tyres, 'tcTyreMake.name')).map(t => ({
        count: t.length,
        percentage: t.length / tyres.length,
        brand: t[0].tcTyreMake ? t[0].tcTyreMake.name : 'Unknown',
      }))
      const step2 = _.orderBy(step1, ['count'], ['desc'])
      return {
        title: { text: 'Tyres by brand' },
        chart: { type: 'pie' },
        plotOptions: {
          pie: {
            cursor: 'pointer',
            dataLabels: { enabled: false },
            showInLegend: true,
          },
        },
        series: [
          {
            data: step2.map(d => ({
              y: d.count,
              name: `${d.brand} - ${d.count} (${_.round(d.percentage * 100, 2)}%)`,
            })),
          },
        ],
      }
    },
    tyresByLife() {
      const { tyres } = this.data
      const step1 = _.values(_.groupBy(tyres, 'tcTyreLife.name')).map(t => ({
        count: t.length,
        percentage: t.length / tyres.length,
        life: t[0].tcTyreLife ? t[0].tcTyreLife.name : 'Unknown',
      }))
      const step2 = _.orderBy(step1, ['count'], ['desc'])
      return {
        title: { text: 'Tyres by life' },
        chart: { type: 'pie' },
        plotOptions: {
          pie: {
            cursor: 'pointer',
            dataLabels: { enabled: false },
            showInLegend: true,
          },
        },
        series: [
          {
            data: step2.map(d => ({
              y: d.count,
              name: `${d.life} - ${d.count} (${_.round(d.percentage * 100, 2)}%)`,
            })),
          },
        ],
      }
    },
    tyresByProduct() {
      const { tyres } = this.data
      const step1 = _.values(_.groupBy(tyres, 'tcTyreProduct.name')).map(t => ({
        count: t.length,
        percentage: t.length / tyres.length,
        product: t[0].tcTyreProduct ? t[0].tcTyreProduct.name : 'Unknown',
      }))
      const step2 = _.orderBy(step1, ['count'], ['desc'])
      return {
        title: { text: 'Tyres by product' },
        chart: { type: 'pie' },
        plotOptions: {
          pie: {
            cursor: 'pointer',
            dataLabels: { enabled: false },
            showInLegend: true,
          },
        },
        series: [
          {
            data: step2.map(d => ({
              y: d.count,
              name: `${d.product} - ${d.count} (${_.round(d.percentage * 100, 2)}%)`,
            })),
          },
        ],
      }
    },
    tyresByPressureStatus() {
      const { tyres } = this.data
      const step1 = tyres.filter(t => t.measurements.pressure != null)
      const onTarget = step1.filter(
        t =>
          t.measurements.pressure >= this.params.lowPressureThreshold &&
          t.measurements.pressure <= this.params.highPressureThreshold,
      )
      const low = step1.filter(t => t.measurements.pressure < this.params.lowPressureThreshold)
      const high = step1.filter(t => t.measurements.pressure > this.params.highPressureThreshold)
      return {
        title: { text: 'Current Pressure Status' },
        chart: { type: 'pie' },
        plotOptions: {
          pie: {
            cursor: 'pointer',
            dataLabels: { enabled: false },
            showInLegend: true,
          },
        },
        series: [
          {
            data: [
              {
                y: onTarget.length,
                name: `On Target`,
                color: 'green',
              },
              {
                y: high.length,
                name: `High`,
                color: 'orange',
              },
              {
                y: low.length,
                name: `Low`,
                color: 'red',
              },
            ],
          },
        ],
      }
    },
    tyresByTreadDepth() {
      const { tyres } = this.data
      const step1 = tyres
        .filter(t => t.measurements.minTreadDepth != null)
        .map(t => ({
          id: t.id,
          treadDepth: units.getCurrentUnitsValue(t.measurements.minTreadDepth, 'treadDepth'),
          roundTreadDepth: _.round(units.getCurrentUnitsValue(t.measurements.minTreadDepth, 'treadDepth')),
        }))

      const step2 = _.groupBy(step1, 'roundTreadDepth')
      const maxTreadDepth = _.max(_.keys(step2))
      const bins = _.range(maxTreadDepth)
      return {
        title: { text: 'Tyres by Tread Depth' },
        chart: { type: 'column' },
        xAxis: { categories: bins },
        yAxis: {
          min: 0,
          title: { text: 'Tyres count' },
        },

        series: [
          {
            name: 'Count',
            data: bins.map(b => (step2[b] ? step2[b].length : 0)),
          },
        ],
      }
    },
    pressureGoal() {
      const { tyres } = this.data
      const step1 = tyres.filter(t => t.measurements.pressure != null)
      const onTarget = step1.filter(
        t =>
          t.measurements.pressure >= this.params.lowPressureThreshold &&
          t.measurements.pressure <= this.params.highPressureThreshold,
      )
      const percentage = onTarget.length / step1.length
      return {
        value: `${_.round(percentage * 100, 2)}%`,
        color: percentage > this.params.pressureGoal ? 'positive' : 'negative',
      }
    },
  },
  methods: {
    async run() {
      await this.$validate()
      if (!this.params.tcFleet) {
        throw new tc.SafeError('Fleet is required')
      }
      this.data = null
      const result = {}

      result.locations = await i2s.queryAll({
        query: dataSources.locations,
        variables: {
          where: {
            tcFleet: this.params.tcFleet,
          },
        },
      })

      result.tyres = await i2s.queryAll({
        query: dataSources.tyres,
        variables: {
          where: {
            tcLocation: { id_in: result.locations.map(l => l.id) },
            stockType_in: this.params.stockTypes,
          },
        },
      })

      this.data = result
    },
  },
}
</script>
